# -- IGWN RHEL packaging workflow

spec:
  inputs:
    redhat_versions:
      default:
        - 8
        - 9
      description: "Versions (number) of Red Hat to build for"
      type: array
    spec_name:
      default: "*.spec"
      description: "Name/pattern to identify the spec file"
    test_install:
      default: ""
      description: "Extra packages to install to support the test_script"
      type: string
    test_script:
      description: "Script commands to run as part of the test job [required]"
      type: array

---

stages:
  - source
  - build
  - test

include:
  - local: templates/sources.yml
    inputs:
      job_name: &sources_name sources
      stage: source
      spec_name: $[[ inputs.spec_name ]]

  - component: $CI_SERVER_FQDN/computing/gitlab/components/redhat/all@main
    inputs:
      needs: [ *sources_name ]
      redhat_versions: $[[ inputs.redhat_versions ]]
      test_install: $[[ inputs.test_install ]]
      test_script: $[[ inputs.test_script ]]

redhat_build:
  before_script:
    - !reference [.redhat_base, before_script]
    # make SRPM
    - dnf -y -q install
        rpm-build
    - rpmbuild
        --define "_srcrpmdir $CI_PROJECT_DIR"
        --define "_sourcedir $CI_PROJECT_DIR"
        -bs $[[ inputs.spec_name ]]
